/// <reference types="node" />
import { EventEmitter } from "events";
import { CancelResult, CheckResult, ReserveResult, SlidingWindowRateLimiterBackend, SlidingWindowRateLimiterBackendOptions } from "./sliding-window-rate-limiter-backend";
export interface MemorySlidingWindowRateLimiterOptions extends SlidingWindowRateLimiterBackendOptions {
}
export declare class MemorySlidingWindowRateLimiter extends EventEmitter implements SlidingWindowRateLimiterBackend {
    readonly options: MemorySlidingWindowRateLimiterOptions;
    readonly interval: number;
    private buckets;
    private timers;
    constructor(options?: MemorySlidingWindowRateLimiterOptions);
    cancel(key: string, token: number): Promise<CancelResult>;
    check(key: string, limit: number): Promise<CheckResult>;
    reserve(key: string, limit: number): Promise<ReserveResult>;
    destroy(): void;
    private bucketResetValue;
    private bucketExpireNow;
}
export default MemorySlidingWindowRateLimiter;
