import { MemorySlidingWindowRateLimiter, MemorySlidingWindowRateLimiterOptions } from "./memory-sliding-window-rate-limiter";
import { RedisSlidingWindowRateLimiter, RedisSlidingWindowRateLimiterOptions } from "./redis-sliding-window-rate-limiter";
import { SafeRedisSlidingWindowRateLimiter, SafeRedisSlidingWindowRateLimiterOptions } from "./safe-redis-sliding-window-rate-limiter";
export * from "./memory-sliding-window-rate-limiter";
export * from "./redis-sliding-window-rate-limiter";
export * from "./safe-redis-sliding-window-rate-limiter";
export * from "./sliding-window-rate-limiter-backend";
export declare class SlidingWindowRateLimiter {
    static createLimiter(options?: MemorySlidingWindowRateLimiterOptions): MemorySlidingWindowRateLimiter;
    static createLimiter(options: RedisSlidingWindowRateLimiterOptions): RedisSlidingWindowRateLimiter;
    static createLimiter(options: SafeRedisSlidingWindowRateLimiterOptions): SafeRedisSlidingWindowRateLimiter;
}
export default SlidingWindowRateLimiter;
