"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SlidingWindowRateLimiter = void 0;
const tslib_1 = require("tslib");
const memory_sliding_window_rate_limiter_1 = require("./memory-sliding-window-rate-limiter");
const redis_sliding_window_rate_limiter_1 = require("./redis-sliding-window-rate-limiter");
const safe_redis_sliding_window_rate_limiter_1 = require("./safe-redis-sliding-window-rate-limiter");
tslib_1.__exportStar(require("./memory-sliding-window-rate-limiter"), exports);
tslib_1.__exportStar(require("./redis-sliding-window-rate-limiter"), exports);
tslib_1.__exportStar(require("./safe-redis-sliding-window-rate-limiter"), exports);
tslib_1.__exportStar(require("./sliding-window-rate-limiter-backend"), exports);
class SlidingWindowRateLimiter {
    static createLimiter(options = {}) {
        if (options.safe && options.redis) {
            return new safe_redis_sliding_window_rate_limiter_1.SafeRedisSlidingWindowRateLimiter(options);
        }
        else if (options.redis) {
            return new redis_sliding_window_rate_limiter_1.RedisSlidingWindowRateLimiter(options);
        }
        else {
            return new memory_sliding_window_rate_limiter_1.MemorySlidingWindowRateLimiter(options);
        }
    }
}
exports.SlidingWindowRateLimiter = SlidingWindowRateLimiter;
exports.default = SlidingWindowRateLimiter;
//# sourceMappingURL=sliding-window-rate-limiter.js.map